--- generate-catalog.py.1	2006-07-16 23:54:31.000000000 +0300
+++ generate-catalog.py	2006-07-17 12:19:26.000000000 +0300
@@ -33,6 +33,8 @@
 import gzip
 import sys
 import locale
+import urllib
+import re
 from cStringIO import StringIO
 
 class Repository:
@@ -47,42 +49,7 @@
 
 
 ARCHITECTURES = ('armel', 'all')
-REPOSITORIES = [
-    Repository(name='Nokia Tableteer Certified',
-	       address='http://catalogue.tableteer.nokia.com/certified'),
-    Repository(name='Nokia Tableteer Non-Certified',
-	       address='http://catalogue.tableteer.nokia.com/non-certified'),
-    Repository(name='Maemo Garage',
-	       address='http://repository.maemo.org/contrib/',
-	       components=['free', 'non-free']),
-    Repository(name='Maemo repository',
-	       address='http://repository.maemo.org/',
-	       components=['free', 'non-free']),
-    Repository(name='FBReader',
-               address='http://only.mawhrin.net/fbreader/maemo/'),
-    Repository(name='Kernel Concepts',
-               address='http://downloads.kernelconcepts.de/maemo2',
-	       components=['free']),
-    Repository(name='Maemo Hackers',
-	       address='http://maemo-hackers.org/apt/',
-	       components=['main']),
-    Repository(name='MUlliNER.ORG Repository',
-	       address='http://www.mulliner.org/nokia770/repository/',
-	       distribution='maemo2',
-	       components=['free']),
-    Repository(name='Oak Court Repository',
-	       address='http://www.oakcourt.dyndns.org/maemo/',
-	       distribution='./',
-	       components=None),
-    Repository(name='Sardine',
-	       address='http://repository.maemo.org',
-	       distribution='sardine',
-	       components=['main', 'non-free']),
-    Repository(name='OpenedHand',
-	       address='http://maemo.o-hand.com/packages',
-	       distribution='mistral/',
-	       components=None)
-]
+REPOSITORIES = []
 
 def load_packages_list(repo):
     assert repo.address is not None
@@ -179,6 +146,30 @@
     apt_pkg.InitConfig()
     apt_pkg.InitSystem()
 
+    title = re.compile('^== (.*) ==')
+    field = re.compile("^ \|\|'''(.*)'''\|\|(.*)\|\|")
+
+    name = None
+    address = None
+    dist = None
+    components = None
+
+    urlhandle = urllib.urlopen('http://maemo.org/maemowiki/ApplicationRepositories?action=raw')
+    for line in urlhandle.readlines():
+        m = title.match(line)
+        if m:
+		name = m.group(1)
+	m = field.match(line)
+	if  m:
+	    if m.group(1) == 'Web address':
+	        address = m.group(2)
+            elif m.group(1) == 'Distribution':
+	        dist = m.group(2)
+            elif m.group(1) == 'Components' and m.group(2) != '(leave blank)':
+	        components = m.group(2).split(' ')
+		REPOSITORIES.append(Repository(name = name, address = address, distribution = dist, components = components))
+
+    urlhandle.close()
 
     packages_by_section = {}
 
